/***********************************************************************************************************************
 * Copyright (c) 2013 CUbRIK Project consortium (http://www.cubrikproject.eu)
 * All rights reserved. This program and the accompanying
 * materials are made available under the terms of the Eclipse Public License v1.0 which accompanies this distribution,
 * and is available at http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors: Lorenzo Eccher (Engineering Ingegneria Informatica S.p.A.) - initial API and implementation
 **********************************************************************************************************************/

package eu.cubrikprj.test.servlet;


import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


/**
 * @author Lorenzo Eccher
 * Company : Engineering Ingegneria Informatica S.P.A.
 * Email : lorenzo.eccher@eng.it
 */
public class TestServlet extends HttpServlet {
	private final static Log _log = LogFactory.getLog(TestServlet.class);
	

	/**
	 * because it's serializable.
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This method retrieve the requested resource from CubrikObjectStoreService
	 * and put it in the response.
	 * {@inheritDoc}
	 *
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest,
	 *      javax.servlet.http.HttpServletResponse)
	 */
	@Override
	protected void doGet(final HttpServletRequest request, final HttpServletResponse response)
			throws ServletException, IOException {
		processRequest(request, response);
	}

	/**
	 * {@inheritDoc}
	 *
	 * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest,
	 *      javax.servlet.http.HttpServletResponse)
	 */
	@Override
	protected void doPost(final HttpServletRequest request, final HttpServletResponse response)
			throws ServletException, IOException {

		processRequest(request, response);
	}

	/**
	 * {@inheritDoc}
	 *
	 * @see javax.servlet.http.HttpServlet#doPut(javax.servlet.http.HttpServletRequest,
	 *      javax.servlet.http.HttpServletResponse)
	 */
	@Override
	protected void doPut(final HttpServletRequest request, final HttpServletResponse response)
			throws ServletException, IOException {
		processRequest(request, response);
	}

	/**
	 * Extract query parameters from request
	 * It uses the CubrikObjectStore service to put the file into the object store
	 * In the response it put the OID generated by the service
	 *
	 * @param request
	 *          HTTP request
	 * @param response
	 *          HTTP response
	 * @throws ServletException
	 *           error during processing
	 * @throws IOException
	 *           error writing result to response stream
	 */
	protected void processRequest(final HttpServletRequest request, final HttpServletResponse response)
			throws ServletException, IOException{
		System.out.println("I am test servlet");
	}

}
